<?php

namespace netim;

/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'StructDomainCheckResponse' => '\\netim\\StructType\\StructDomainCheckResponse',
            'StructDomainList' => '\\netim\\StructType\\StructDomainList',
            'StructHostList' => '\\netim\\StructType\\StructHostList',
            'StructDSRecord' => '\\netim\\StructType\\StructDSRecord',
            'StructTld' => '\\netim\\StructType\\StructTld',
            'StructContact' => '\\netim\\StructType\\StructContact',
            'StructOwnerContact' => '\\netim\\StructType\\StructOwnerContact',
            'StructContactReturn' => '\\netim\\StructType\\StructContactReturn',
            'StructDomainInfo' => '\\netim\\StructType\\StructDomainInfo',
            'StructDomainTldInfo' => '\\netim\\StructType\\StructDomainTldInfo',
            'StructDomainPriceList' => '\\netim\\StructType\\StructDomainPriceList',
            'StructQueryOpeList' => '\\netim\\StructType\\StructQueryOpeList',
            'StructContactList' => '\\netim\\StructType\\StructContactList',
            'StructOptionsFwd' => '\\netim\\StructType\\StructOptionsFwd',
            'StructOptionsZone' => '\\netim\\StructType\\StructOptionsZone',
            'StructQueryZoneList' => '\\netim\\StructType\\StructQueryZoneList',
            'StructQueryMailFwdList' => '\\netim\\StructType\\StructQueryMailFwdList',
            'StructQueryWebFwdList' => '\\netim\\StructType\\StructQueryWebFwdList',
            'KeyValueData' => '\\netim\\StructType\\KeyValueData',
            'ArrayOfKeyValueData' => '\\netim\\ArrayType\\ArrayOfKeyValueData',
            'StructQueryResellerAccount' => '\\netim\\StructType\\StructQueryResellerAccount',
            'StructQueryOpePending' => '\\netim\\StructType\\StructQueryOpePending',
            'StructQueryDomainPrice' => '\\netim\\StructType\\StructQueryDomainPrice',
            'StructSessionInfo' => '\\netim\\StructType\\StructSessionInfo',
            'StructOperationResponse' => '\\netim\\StructType\\StructOperationResponse',
            'StructSSLInfo' => '\\netim\\StructType\\StructSSLInfo',
            'StructCSR' => '\\netim\\StructType\\StructCSR',
        );
    }
}
