<?php

namespace netim\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for StructContact StructType
 * @subpackage Structs
 */
class StructContact extends AbstractStructBase
{
    /**
     * The firstName
     * @var string
     */
    public $firstName;
    /**
     * The lastName
     * @var string
     */
    public $lastName;
    /**
     * The bodyForm
     * @var string
     */
    public $bodyForm;
    /**
     * The bodyName
     * @var string
     */
    public $bodyName;
    /**
     * The address1
     * @var string
     */
    public $address1;
    /**
     * The address2
     * @var string
     */
    public $address2;
    /**
     * The zipCode
     * @var string
     */
    public $zipCode;
    /**
     * The area
     * @var string
     */
    public $area;
    /**
     * The city
     * @var string
     */
    public $city;
    /**
     * The country
     * @var string
     */
    public $country;
    /**
     * The phone
     * @var string
     */
    public $phone;
    /**
     * The fax
     * @var string
     */
    public $fax;
    /**
     * The email
     * @var string
     */
    public $email;
    /**
     * The language
     * @var string
     */
    public $language;
    /**
     * The isOwner
     * @var int
     */
    public $isOwner;
    /**
     * The tmName
     * @var string
     */
    public $tmName;
    /**
     * The tmNumber
     * @var string
     */
    public $tmNumber;
    /**
     * The tmType
     * @var string
     */
    public $tmType;
    /**
     * The tmDate
     * @var string
     */
    public $tmDate;
    /**
     * The companyNumber
     * @var string
     */
    public $companyNumber;
    /**
     * The vatNumber
     * @var string
     */
    public $vatNumber;
    /**
     * The birthDate
     * @var string
     */
    public $birthDate;
    /**
     * The birthZipCode
     * @var string
     */
    public $birthZipCode;
    /**
     * The birthCity
     * @var string
     */
    public $birthCity;
    /**
     * The birthCountry
     * @var string
     */
    public $birthCountry;
    /**
     * The idNumber
     * @var string
     */
    public $idNumber;
    /**
     * The additional
     * @var mixed
     */
    public $additional;
    /**
     * Constructor method for StructContact
     * @uses StructContact::setFirstName()
     * @uses StructContact::setLastName()
     * @uses StructContact::setBodyForm()
     * @uses StructContact::setBodyName()
     * @uses StructContact::setAddress1()
     * @uses StructContact::setAddress2()
     * @uses StructContact::setZipCode()
     * @uses StructContact::setArea()
     * @uses StructContact::setCity()
     * @uses StructContact::setCountry()
     * @uses StructContact::setPhone()
     * @uses StructContact::setFax()
     * @uses StructContact::setEmail()
     * @uses StructContact::setLanguage()
     * @uses StructContact::setIsOwner()
     * @uses StructContact::setTmName()
     * @uses StructContact::setTmNumber()
     * @uses StructContact::setTmType()
     * @uses StructContact::setTmDate()
     * @uses StructContact::setCompanyNumber()
     * @uses StructContact::setVatNumber()
     * @uses StructContact::setBirthDate()
     * @uses StructContact::setBirthZipCode()
     * @uses StructContact::setBirthCity()
     * @uses StructContact::setBirthCountry()
     * @uses StructContact::setIdNumber()
     * @uses StructContact::setAdditional()
     * @param string $firstName
     * @param string $lastName
     * @param string $bodyForm
     * @param string $bodyName
     * @param string $address1
     * @param string $address2
     * @param string $zipCode
     * @param string $area
     * @param string $city
     * @param string $country
     * @param string $phone
     * @param string $fax
     * @param string $email
     * @param string $language
     * @param int $isOwner
     * @param string $tmName
     * @param string $tmNumber
     * @param string $tmType
     * @param string $tmDate
     * @param string $companyNumber
     * @param string $vatNumber
     * @param string $birthDate
     * @param string $birthZipCode
     * @param string $birthCity
     * @param string $birthCountry
     * @param string $idNumber
     * @param mixed $additional
     */
    public function __construct($firstName = null, $lastName = null, $bodyForm = null, $bodyName = null, $address1 = null, $address2 = null, $zipCode = null, $area = null, $city = null, $country = null, $phone = null, $fax = null, $email = null, $language = null, $isOwner = null, $tmName = null, $tmNumber = null, $tmType = null, $tmDate = null, $companyNumber = null, $vatNumber = null, $birthDate = null, $birthZipCode = null, $birthCity = null, $birthCountry = null, $idNumber = null, $additional = null)
    {
        $this
            ->setFirstName($firstName)
            ->setLastName($lastName)
            ->setBodyForm($bodyForm)
            ->setBodyName($bodyName)
            ->setAddress1($address1)
            ->setAddress2($address2)
            ->setZipCode($zipCode)
            ->setArea($area)
            ->setCity($city)
            ->setCountry($country)
            ->setPhone($phone)
            ->setFax($fax)
            ->setEmail($email)
            ->setLanguage($language)
            ->setIsOwner($isOwner)
            ->setTmName($tmName)
            ->setTmNumber($tmNumber)
            ->setTmType($tmType)
            ->setTmDate($tmDate)
            ->setCompanyNumber($companyNumber)
            ->setVatNumber($vatNumber)
            ->setBirthDate($birthDate)
            ->setBirthZipCode($birthZipCode)
            ->setBirthCity($birthCity)
            ->setBirthCountry($birthCountry)
            ->setIdNumber($idNumber)
            ->setAdditional($additional);
    }
    /**
     * Get firstName value
     * @return string|null
     */
    public function getFirstName()
    {
        return $this->firstName;
    }
    /**
     * Set firstName value
     * @param string $firstName
     * @return \netim\StructType\StructContact
     */
    public function setFirstName($firstName = null)
    {
        // validation for constraint: string
        if (!is_null($firstName) && !is_string($firstName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($firstName)), __LINE__);
        }
        $this->firstName = $firstName;
        return $this;
    }
    /**
     * Get lastName value
     * @return string|null
     */
    public function getLastName()
    {
        return $this->lastName;
    }
    /**
     * Set lastName value
     * @param string $lastName
     * @return \netim\StructType\StructContact
     */
    public function setLastName($lastName = null)
    {
        // validation for constraint: string
        if (!is_null($lastName) && !is_string($lastName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($lastName)), __LINE__);
        }
        $this->lastName = $lastName;
        return $this;
    }
    /**
     * Get bodyForm value
     * @return string|null
     */
    public function getBodyForm()
    {
        return $this->bodyForm;
    }
    /**
     * Set bodyForm value
     * @param string $bodyForm
     * @return \netim\StructType\StructContact
     */
    public function setBodyForm($bodyForm = null)
    {
        // validation for constraint: string
        if (!is_null($bodyForm) && !is_string($bodyForm)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($bodyForm)), __LINE__);
        }
        $this->bodyForm = $bodyForm;
        return $this;
    }
    /**
     * Get bodyName value
     * @return string|null
     */
    public function getBodyName()
    {
        return $this->bodyName;
    }
    /**
     * Set bodyName value
     * @param string $bodyName
     * @return \netim\StructType\StructContact
     */
    public function setBodyName($bodyName = null)
    {
        // validation for constraint: string
        if (!is_null($bodyName) && !is_string($bodyName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($bodyName)), __LINE__);
        }
        $this->bodyName = $bodyName;
        return $this;
    }
    /**
     * Get address1 value
     * @return string|null
     */
    public function getAddress1()
    {
        return $this->address1;
    }
    /**
     * Set address1 value
     * @param string $address1
     * @return \netim\StructType\StructContact
     */
    public function setAddress1($address1 = null)
    {
        // validation for constraint: string
        if (!is_null($address1) && !is_string($address1)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($address1)), __LINE__);
        }
        $this->address1 = $address1;
        return $this;
    }
    /**
     * Get address2 value
     * @return string|null
     */
    public function getAddress2()
    {
        return $this->address2;
    }
    /**
     * Set address2 value
     * @param string $address2
     * @return \netim\StructType\StructContact
     */
    public function setAddress2($address2 = null)
    {
        // validation for constraint: string
        if (!is_null($address2) && !is_string($address2)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($address2)), __LINE__);
        }
        $this->address2 = $address2;
        return $this;
    }
    /**
     * Get zipCode value
     * @return string|null
     */
    public function getZipCode()
    {
        return $this->zipCode;
    }
    /**
     * Set zipCode value
     * @param string $zipCode
     * @return \netim\StructType\StructContact
     */
    public function setZipCode($zipCode = null)
    {
        // validation for constraint: string
        if (!is_null($zipCode) && !is_string($zipCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($zipCode)), __LINE__);
        }
        $this->zipCode = $zipCode;
        return $this;
    }
    /**
     * Get area value
     * @return string|null
     */
    public function getArea()
    {
        return $this->area;
    }
    /**
     * Set area value
     * @param string $area
     * @return \netim\StructType\StructContact
     */
    public function setArea($area = null)
    {
        // validation for constraint: string
        if (!is_null($area) && !is_string($area)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($area)), __LINE__);
        }
        $this->area = $area;
        return $this;
    }
    /**
     * Get city value
     * @return string|null
     */
    public function getCity()
    {
        return $this->city;
    }
    /**
     * Set city value
     * @param string $city
     * @return \netim\StructType\StructContact
     */
    public function setCity($city = null)
    {
        // validation for constraint: string
        if (!is_null($city) && !is_string($city)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($city)), __LINE__);
        }
        $this->city = $city;
        return $this;
    }
    /**
     * Get country value
     * @return string|null
     */
    public function getCountry()
    {
        return $this->country;
    }
    /**
     * Set country value
     * @param string $country
     * @return \netim\StructType\StructContact
     */
    public function setCountry($country = null)
    {
        // validation for constraint: string
        if (!is_null($country) && !is_string($country)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($country)), __LINE__);
        }
        $this->country = $country;
        return $this;
    }
    /**
     * Get phone value
     * @return string|null
     */
    public function getPhone()
    {
        return $this->phone;
    }
    /**
     * Set phone value
     * @param string $phone
     * @return \netim\StructType\StructContact
     */
    public function setPhone($phone = null)
    {
        // validation for constraint: string
        if (!is_null($phone) && !is_string($phone)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($phone)), __LINE__);
        }
        $this->phone = $phone;
        return $this;
    }
    /**
     * Get fax value
     * @return string|null
     */
    public function getFax()
    {
        return $this->fax;
    }
    /**
     * Set fax value
     * @param string $fax
     * @return \netim\StructType\StructContact
     */
    public function setFax($fax = null)
    {
        // validation for constraint: string
        if (!is_null($fax) && !is_string($fax)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($fax)), __LINE__);
        }
        $this->fax = $fax;
        return $this;
    }
    /**
     * Get email value
     * @return string|null
     */
    public function getEmail()
    {
        return $this->email;
    }
    /**
     * Set email value
     * @param string $email
     * @return \netim\StructType\StructContact
     */
    public function setEmail($email = null)
    {
        // validation for constraint: string
        if (!is_null($email) && !is_string($email)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($email)), __LINE__);
        }
        $this->email = $email;
        return $this;
    }
    /**
     * Get language value
     * @return string|null
     */
    public function getLanguage()
    {
        return $this->language;
    }
    /**
     * Set language value
     * @param string $language
     * @return \netim\StructType\StructContact
     */
    public function setLanguage($language = null)
    {
        // validation for constraint: string
        if (!is_null($language) && !is_string($language)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($language)), __LINE__);
        }
        $this->language = $language;
        return $this;
    }
    /**
     * Get isOwner value
     * @return int|null
     */
    public function getIsOwner()
    {
        return $this->isOwner;
    }
    /**
     * Set isOwner value
     * @param int $isOwner
     * @return \netim\StructType\StructContact
     */
    public function setIsOwner($isOwner = null)
    {
        // validation for constraint: int
        if (!is_null($isOwner) && !is_numeric($isOwner)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($isOwner)), __LINE__);
        }
        $this->isOwner = $isOwner;
        return $this;
    }
    /**
     * Get tmName value
     * @return string|null
     */
    public function getTmName()
    {
        return $this->tmName;
    }
    /**
     * Set tmName value
     * @param string $tmName
     * @return \netim\StructType\StructContact
     */
    public function setTmName($tmName = null)
    {
        // validation for constraint: string
        if (!is_null($tmName) && !is_string($tmName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($tmName)), __LINE__);
        }
        $this->tmName = $tmName;
        return $this;
    }
    /**
     * Get tmNumber value
     * @return string|null
     */
    public function getTmNumber()
    {
        return $this->tmNumber;
    }
    /**
     * Set tmNumber value
     * @param string $tmNumber
     * @return \netim\StructType\StructContact
     */
    public function setTmNumber($tmNumber = null)
    {
        // validation for constraint: string
        if (!is_null($tmNumber) && !is_string($tmNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($tmNumber)), __LINE__);
        }
        $this->tmNumber = $tmNumber;
        return $this;
    }
    /**
     * Get tmType value
     * @return string|null
     */
    public function getTmType()
    {
        return $this->tmType;
    }
    /**
     * Set tmType value
     * @param string $tmType
     * @return \netim\StructType\StructContact
     */
    public function setTmType($tmType = null)
    {
        // validation for constraint: string
        if (!is_null($tmType) && !is_string($tmType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($tmType)), __LINE__);
        }
        $this->tmType = $tmType;
        return $this;
    }
    /**
     * Get tmDate value
     * @return string|null
     */
    public function getTmDate()
    {
        return $this->tmDate;
    }
    /**
     * Set tmDate value
     * @param string $tmDate
     * @return \netim\StructType\StructContact
     */
    public function setTmDate($tmDate = null)
    {
        // validation for constraint: string
        if (!is_null($tmDate) && !is_string($tmDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($tmDate)), __LINE__);
        }
        $this->tmDate = $tmDate;
        return $this;
    }
    /**
     * Get companyNumber value
     * @return string|null
     */
    public function getCompanyNumber()
    {
        return $this->companyNumber;
    }
    /**
     * Set companyNumber value
     * @param string $companyNumber
     * @return \netim\StructType\StructContact
     */
    public function setCompanyNumber($companyNumber = null)
    {
        // validation for constraint: string
        if (!is_null($companyNumber) && !is_string($companyNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($companyNumber)), __LINE__);
        }
        $this->companyNumber = $companyNumber;
        return $this;
    }
    /**
     * Get vatNumber value
     * @return string|null
     */
    public function getVatNumber()
    {
        return $this->vatNumber;
    }
    /**
     * Set vatNumber value
     * @param string $vatNumber
     * @return \netim\StructType\StructContact
     */
    public function setVatNumber($vatNumber = null)
    {
        // validation for constraint: string
        if (!is_null($vatNumber) && !is_string($vatNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($vatNumber)), __LINE__);
        }
        $this->vatNumber = $vatNumber;
        return $this;
    }
    /**
     * Get birthDate value
     * @return string|null
     */
    public function getBirthDate()
    {
        return $this->birthDate;
    }
    /**
     * Set birthDate value
     * @param string $birthDate
     * @return \netim\StructType\StructContact
     */
    public function setBirthDate($birthDate = null)
    {
        // validation for constraint: string
        if (!is_null($birthDate) && !is_string($birthDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($birthDate)), __LINE__);
        }
        $this->birthDate = $birthDate;
        return $this;
    }
    /**
     * Get birthZipCode value
     * @return string|null
     */
    public function getBirthZipCode()
    {
        return $this->birthZipCode;
    }
    /**
     * Set birthZipCode value
     * @param string $birthZipCode
     * @return \netim\StructType\StructContact
     */
    public function setBirthZipCode($birthZipCode = null)
    {
        // validation for constraint: string
        if (!is_null($birthZipCode) && !is_string($birthZipCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($birthZipCode)), __LINE__);
        }
        $this->birthZipCode = $birthZipCode;
        return $this;
    }
    /**
     * Get birthCity value
     * @return string|null
     */
    public function getBirthCity()
    {
        return $this->birthCity;
    }
    /**
     * Set birthCity value
     * @param string $birthCity
     * @return \netim\StructType\StructContact
     */
    public function setBirthCity($birthCity = null)
    {
        // validation for constraint: string
        if (!is_null($birthCity) && !is_string($birthCity)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($birthCity)), __LINE__);
        }
        $this->birthCity = $birthCity;
        return $this;
    }
    /**
     * Get birthCountry value
     * @return string|null
     */
    public function getBirthCountry()
    {
        return $this->birthCountry;
    }
    /**
     * Set birthCountry value
     * @param string $birthCountry
     * @return \netim\StructType\StructContact
     */
    public function setBirthCountry($birthCountry = null)
    {
        // validation for constraint: string
        if (!is_null($birthCountry) && !is_string($birthCountry)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($birthCountry)), __LINE__);
        }
        $this->birthCountry = $birthCountry;
        return $this;
    }
    /**
     * Get idNumber value
     * @return string|null
     */
    public function getIdNumber()
    {
        return $this->idNumber;
    }
    /**
     * Set idNumber value
     * @param string $idNumber
     * @return \netim\StructType\StructContact
     */
    public function setIdNumber($idNumber = null)
    {
        // validation for constraint: string
        if (!is_null($idNumber) && !is_string($idNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($idNumber)), __LINE__);
        }
        $this->idNumber = $idNumber;
        return $this;
    }
    /**
     * Get additional value
     * @return mixed|null
     */
    public function getAdditional()
    {
        return $this->additional;
    }
    /**
     * Set additional value
     * @param mixed $additional
     * @return \netim\StructType\StructContact
     */
    public function setAdditional($additional = null)
    {
        $this->additional = $additional;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \netim\StructType\StructContact
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
